''	FreeBASIC - 32-bit BASIC Compiler.
''	Copyright (C) 2004-2005 Andre Victor T. Vicentini (av1ctor@yahoo.com.br)
''
''	This program is free software; you can redistribute it and/or modify
''	it under the terms of the GNU General Public License as published by
''	the Free Software Foundation; either version 2 of the License, or
''	(at your option) any later version.
''
''	This program is distributed in the hope that it will be useful,
''	but WITHOUT ANY WARRANTY; without even the implied warranty of
''	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
''	GNU General Public License for more details.
''
''	You should have received a copy of the GNU General Public License
''	along with this program; if not, write to the Free Software
''	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.


'' atom constants and literals parsing
''
'' chng: sep/2004 written [v1ctor]

option explicit
option escape

#include once "inc\fb.bi"
#include once "inc\fbint.bi"
#include once "inc\parser.bi"
#include once "inc\ast.bi"

'':::::
'' Constant       = ID .
''
function cConstant( byref constexpr as ASTNODE ptr ) as integer static
	dim as FBSYMBOL ptr s
	dim as integer dtype

	function = FALSE

	s = symbFindByClass( lexGetSymbol( ), FB_SYMBCLASS_CONST )
	if( s <> NULL ) then

  		dtype = symbGetType( s )
  		select case as const dtype
  		case IR_DATATYPE_CHAR, IR_DATATYPE_WCHAR
  			constexpr = astNewVAR( symbGetConstValStr( s ), 0, dtype )

  		case IR_DATATYPE_ENUM
  			constexpr = astNewENUM( symbGetConstValInt( s ), symbGetSubType( s ) )

  		case IR_DATATYPE_LONGINT, IR_DATATYPE_ULONGINT
  			constexpr = astNewCONST64( symbGetConstValLong( s ), dtype )

  		case IR_DATATYPE_SINGLE, IR_DATATYPE_DOUBLE
  			constexpr = astNewCONSTf( symbGetConstValFloat( s ), dtype )

  		case else
  			constexpr = astNewCONSTi( symbGetConstValInt( s ), dtype, symbGetSubType( s ) )

  		end select

  		lexSkipToken( )
  		function = TRUE
  	end if

end function

'':::::
''Literal		  = NUM_LITERAL | STR_LITERAL .
''
function cLiteral( byref litexpr as ASTNODE ptr ) as integer
	dim as FBSYMBOL ptr s
	dim as integer typ

	function = FALSE

	select case lexGetClass( )
	case FB_TKCLASS_NUMLITERAL
  		typ = lexGetType( )
  		select case as const typ
  		case IR_DATATYPE_LONGINT
			litexpr = astNewCONST64( vallng( *lexGetText( ) ), typ )

		case IR_DATATYPE_ULONGINT
			litexpr = astNewCONST64( valulng( *lexGetText( ) ), typ )

  		case IR_DATATYPE_SINGLE, IR_DATATYPE_DOUBLE
			litexpr = astNewCONSTf( val( *lexGetText( ) ), typ )

		case IR_DATATYPE_UINT
			litexpr = astNewCONSTi( valuint( *lexGetText( ) ), typ )

		case else
			litexpr = astNewCONSTi( valint( *lexGetText( ) ), typ )
  		end select

  		lexSkipToken( )
  		function = TRUE

  	case FB_TKCLASS_STRLITERAL
  		typ = lexGetType( )

  		if( typ <> IR_DATATYPE_WCHAR ) then
			s = symbAllocStrConst( *lexGetText( ), lexGetTextLen( ) )
  		else
			s = symbAllocWstrConst( *lexGetTextW( ), lexGetTextLen( ) )
		end if

		litexpr = astNewVAR( s, 0, typ )

		lexSkipToken( )
        function = TRUE
  	end select

end function

