/*
 *  libfb - FreeBASIC's runtime library
 *	Copyright (C) 2004-2005 Andre V. T. Vicentini (av1ctor@yahoo.com.br) and others.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 *	file_seek - seek function and stmt
 *
 * chng: oct/2004 written [marzec/v1ctor]
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "fb.h"
#include "fb_rterr.h"


/*:::::*/
long fb_FileLocationEx( FB_FILE *handle )
{
    long pos;

    if( !FB_HANDLE_USED(handle) )
		return 0;

    FB_LOCK();

    pos = fb_FileTellEx( handle );

    if (pos != 0) {
        --pos;
        switch( handle->mode )
        {
        case FB_FILE_MODE_INPUT:
        case FB_FILE_MODE_OUTPUT:
            /* if in seq mode, divide by 128 (QB quirk) */
            pos /= 128;
            break;
        }
    }

	FB_UNLOCK();

	return pos;
}

/*:::::*/
FBCALL long fb_FileLocation( int fnum )
{
    return fb_FileLocationEx( FB_FILE_TO_HANDLE(fnum) );
}

